C STORAGE:2
C NOFLOATCALLS
C THE PRECEDING (LINE) IS ONLY TO BE INCLUDED IF THE PROG IS TO RUN ON AN 8087
C IF THIS LINE IS INCLUDED LINK TO THE 8087.LIB
C
C                                      DO NOT ERASE
C     ******************************************************************
C     *                                                                *
C     *   CXTFIT:  NON-LINEAR LEAST-SQUARES ANALYSIS OF C(X,T) DATA    *
C     *   FOR  ONE-DIMENSIONAL  DETERMINISTIC OR STOCHASTIC  SOLUTE    *
C     *   TRANSPORT  WITH  DETECTION  IN  RESIDENT  OR  FLUX  MODES    *
C     *                                                                *
C     *                                                                *
C     *   SEE:   J. C. PARKER AND M. TH. VAN GENUCHTEN. 1984.          *
C     *   "DETERMINING TRANSPORT PARAMETERS FROM LABORATORY AND        *
C     *    FIELD TRACER EXPERIMENTS"  VA. AG. EXP. STA. BULL. 84-3.    *
C     *                                                                *
C     *                                    VERSION  1.3 January 1985   *
C     *                                     IBM PC VERSION             *
C     ******************************************************************
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      real rone,rtwo,rthree,rfour,rfive,rsix,rseven
      INTEGER FLAG7
      CHARACTER*15 FILENAME1, FILENAME2, XLABEL
      DIMENSION C(90),F(90),R(90),DELZ(90,7),B(14),E(7),TH(14),P(7),
     1PHI(7),Q(7),LSORT(90),TB(14),A(7,7),BI(14)       ,D(7,7),
     2BMAX(7),BMIN(7)
      COMMON/MODAT1/X(90),T(90),INDEX(7),NOB,NREDU,NVAR
      COMMON/MODAT2/CI,C0,DM1,XL,DM2,DM3,DM4,DM5,DM6,DM7,DM8,DM9,DM10,
     1DM11,DM12,MODE,MODT
      COMMON/MODAT3/TPULSE(11),PULSE(11),CITEMP,NPULSE
      DATA STOPCR/0.0005/
      DATA MAXTRY/50/

      FLAG7 = 0
C
C     INITIALIZE UNITS 5 AND 6
      WRITE(*, 2001)
      READ(*, 2003) FILENAME1
C
      WRITE(*, 2002)
      READ(*, 2003) FILENAME2
      OPEN(6, FILE = FILENAME2, STATUS = 'unknown')
      OPEN(5, FILE = FILENAME1, STATUS = 'OLD')
C
C
C     ----- READ NUMBER OF CASES -----
      READ(5,1006) NC
C
C
C     ----- READ INPUT PARAMETERS -----
      READ(5,1006) MODE,NDATA,NREDU,MIT,NOB,NSKIP,NPRNT
C
C UNIT 7 DECLARATION
      IF (NPRNT.GE.2) THEN
        IF(FLAG7.EQ.0) THEN
            OPEN(UNIT = 7, FILE = 'pd.dat', STATUS = 'unknown')
            FLAG7 = 1
            IF (NPRNT.EQ.2) THEN
                XLABEL = ' DISTANCE'
              ELSE
                XLABEL = ' TIME'
            ENDIF
            WRITE(7, 2003) XLABEL
          ELSE
            NPRNT = 0
        ENDIF
      ENDIF

      IF(NSKIP.NE.0) GO TO 2
      WRITE(6,1000)
      IF(MIT.NE.0) WRITE(6,1035)
      WRITE(6,1036)
      M=(MODE-1)/2
      IF(M.EQ.0) WRITE(6,1021)
      IF(M.EQ.1) WRITE(6,1022)
      IF(M.EQ.2) WRITE(6,1023)
      IF(M.EQ.3) WRITE(6,1039)
      N=MODE-2*M
      IF(N.EQ.1) WRITE(6,1024)
      IF(N.EQ.2) WRITE(6,1025)
      IF(NREDU.EQ.1) WRITE(6,1037)
      IF(NREDU.EQ.2) WRITE(6,1040)
      WRITE(6,1036)
    2 NVAR=6
      IF(MODE.GE.5) NVAR=7
      NU1=NVAR+1
      NU2=2*NVAR
C     DO 4 I=1,2
C     READ(5,1001) TITLE
C   4 IF(NSKIP.EQ.0) WRITE(6,1002) TITLE
      IF(NSKIP.EQ.0) WRITE(6,1003)
C
C     ----- READ COEFFICIENTS NAMES -----
      READ(5,1004) (BI(I),I=1,NU2)
C
C     ----- READ INITIAL ESTIMATES -----
      READ(5,1005) (B(I),I=NU1,NU2)
C
C     ----- READ INDICES -----
      READ(5,1044) (INDEX(I),I=1,NVAR)
      ILMT=1.0
C
C     ----- READ CONSTRAINTS ON PARAMETER VALUES -----
      IF(ILMT.EQ.0)GO TO 5
      READ(5,1005) (BMIN(I),I=1,NVAR)
      READ(5,1005) (BMAX(I),I=1,NVAR)
    5 IF((MODE.LT.3).OR.(MODE.GT.4))GO TO 6
      IF((BMAX(5).EQ.0.).OR.(BMAX(5).GT.1.))BMAX(5)=1.0
C
C     ----- READ INITIAL AND INLET CONCENTRATIONS -----
    6 READ(5,1045) CI,C0,NPULSE
      IF(NPULSE.LT.1) NPULSE=1
      IF(NSKIP.NE.0)GO TO 8
      WRITE(6,1007)
      DO 7  I=1,NVAR
      IF((NPULSE.GT.1).AND.(I.EQ.4))GO TO 7
      J=2*I-1
      WRITE(6,1008) BI(J),BI(J+1),B(I+NVAR)
    7 CONTINUE
    8 IF(NSKIP.EQ.0) WRITE(6,1026) CI
      IF((NSKIP.EQ.0).AND.((NPULSE.EQ.1).OR.(MODE.GE.7)))
     1 WRITE(6,1049) C0
      IF(NPULSE.EQ.1)GO TO 11
      IF(NSKIP.NE.0)GO TO 9
      IF(MODE.LE.6) WRITE(6,1046)
      IF(MODE.GT.6) WRITE(6,1047)
    9 INDEX(4)=0
      DO 10 I=1,NPULSE
      NUM=0
      IF(MODE.LT.7)NUM=1
      READ(5,1005)TPULSE(I+NUM),PULSE(I+1)
      IF((NSKIP.EQ.0).AND.(MODE.LT.7))
     1 WRITE(6,1048)I,TPULSE(I),TPULSE(I+1),PULSE(I+1)
   10 IF((NSKIP.EQ.0).AND.(MODE.GE.7))
     1 WRITE(6,1048)I,TPULSE(I),PULSE(I+1)
   11 IF(NDATA.NE.1) GO TO 13
C
C     ----- READ AND WRITE EXPERIMENTAL DATA -----
      XL=0.0
      DO 12 I=1,NOB
      READ(5,1005) C(I),X(I),T(I)
   12 XL=DMAX1(XL,X(I))
   13 continue
      IF(NREDU.NE.2) GO TO 17
      INDEX(1)=0
   17 continue
      IF(NPRNT.NE.1) GO TO 25
      WRITE(6,1009)
      DO 24 I=1,NOB
   24 WRITE(6,1010) I,C(I),X(I),T(I)
C
C     -----CHECK FOR INPUT ERROR-----
   25 NZC=0
      NFC=0
      DO 27 I=1,NVAR
      IF((I.EQ.4).OR.(MODE.GE.5)) GO TO 27
      IF(INDEX(I).EQ.1) NFC=NFC+1
      IF(B(I+NVAR).NE.0.0) NZC=NZC+1
   27 CONTINUE
C
C     ----- REARRANGE VARIABLE ARRAYS -----
C
C     START THE ANNEALING PROCESS
C
      WRITE(6,9997)
 9997 FORMAT(//4X,'N',5X,'SSQ',7X,'V',8X,'D',8X,'R',7X,'T',7X,'BETA',5X,
     $      'ALPHA')
      NIT=0
      NNC=0
      RONE=1139.
      RTWO=2139.
      RTHREE=10139.
      RFOUR=4139.
      RFIVE=5139.
      DO 90 I=NU1,NU2
      IF(INDEX(I-NVAR).EQ.0) GO TO 90
      GOTO 90
   91   CALL RANDOM3(RTHREE)
        B(I)=B(I)+B(I)*(2.*RTHREE-1.)
        IF(B(I).LT.BMIN(I-NVAR).OR.B(I).GT.BMAX(I-NVAR)) THEN
          B(I)=B(I)-B(I)*(2.*RTHREE-1.)
          GOTO 91
      ENDIF
   90 CONTINUE
      CALL MODEL(B,F)
      SSQ0=0.
      SSQ=1000.
      DO 32 I=1,NOB
      R(I)=C(I)-F(I)
   32 SSQ0=SSQ0+R(I)*R(I)
      WRITE(6,9012) NIT,SSQ0,(B(I),I=NU1,NU2)
 9012 FORMAT(I5,F10.6,6F9.5)
      SSQMIN=SSQ0
      SSQMIN0=SSQ0
      T00=500.
  35  NIT=NIT+1
      NVB=4
      IF(SSQ0.LE.0.0001.OR.NIT.GE.10000.OR.NNC.GT.100) GOTO 37
      DO 31 J=1,500
      DO 30 I=NU1,NU2
      TB(I)=B(I)
      IF(INDEX(I-NVAR).EQ.0) GO TO 30

   50 CONTINUE
      IF(NVB.EQ.1) THEN
        CALL RANDOM(RONE)
        TB(I)=TB(I)+0.2*(2.*RONE-1.)
        IF(TB(I).LT.BMIN(I-NVAR).OR.TB(I).GT.BMAX(I-NVAR)) THEN
          TB(I)=TB(I)-0.2*(2.*RONE-1.)
          GOTO 50
        ENDIF
      ENDIF
      IF(NVB.EQ.2) THEN
        CALL RANDOM3(RTHREE)
        TB(I)=TB(I)+0.2*(2.*RTHREE-1.)
        IF(TB(I).LT.BMIN(I-NVAR).OR.TB(I).GT.BMAX(I-NVAR)) THEN
          TB(I)=TB(I)-0.2*(2.*RTHREE-1.)
          GOTO 50
        ENDIF
      ENDIF
      IF(NVB.EQ.3) THEN
        CALL RANDOM4(RFOUR)
        TB(I)=TB(I)+0.2*(2.*RFOUR-1.)
        IF(TB(I).LT.BMIN(I-NVAR).OR.TB(I).GT.BMAX(I-NVAR)) THEN
          TB(I)=TB(I)-0.2*(2.*RFOUR-1.)
          GOTO 50
        ENDIF
      ENDIF
      IF(NVB.EQ.4) THEN
        CALL RANDOM5(RFIVE)
        TB(I)=TB(I)+0.2*(2.*RFIVE-1.)
        IF(TB(I).LT.BMIN(I-NVAR).OR.TB(I).GT.BMAX(I-NVAR)) THEN
          TB(I)=TB(I)-0.2*(2.*RFIVE-1.)
          GOTO 50
        ENDIF
      ENDIF
   30 CONTINUE
      CALL MODEL(TB,F)
      SSQ=0.0
      DO 34 I=1,NOB
      R(I)=C(I)-F(I)
   34 SSQ=SSQ+R(I)*R(I)
      CALL RANDOM2(RTWO)
      PER=EXP(-1.*(SSQ-SSQ0)/T00)
      IF(SSQ.LE.SSQ0.OR.RTWO.GT.PER) THEN
        DO 36 I=NU1,NU2
          B(I)=TB(I)
   36   CONTINUE
        SSQ0=SSQ
      ENDIF
      IF(SSQMIN.GT.SSQ0) THEN
        SSQMIN=SSQ0
        DO 38 I=NU1,NU2
          TH(I)=B(I)
   38   CONTINUE
      ENDIF
   31 CONTINUE
      IF(SSQMIN0.NE.SSQMIN) THEN
        SSQMIN0=SSQMIN
      ELSE
        NNC=NNC+1
      ENDIF
      SSQ0=SSQMIN
      DO 40 I=NU1,NU2
        B(I)=TH(I)
   40 CONTINUE
      T00=T00*0.95
      IF(ABS(NIT/1.-INT(NIT/1.)).LE.0.0000001)
     1 WRITE(6,9012) NIT,SSQ0,(B(I),I=NU1,NU2)
      GOTO 35
   37 CONTINUE
      WRITE(6,9012) NIT,SSQ0,(B(I),I=NU1,NU2)
      CALL MODEL(B,F)
	WRITE(6,9998)
      WRITE(6,9999) (C(I),F(I),I=1,NOB)
 9998 FORMAT(//5X,'OBSERVED C',5X,'CALCULATED C')
 9999 FORMAT(F13.4,6X,F13.4)

C
C     ----- END OF PROBLEM -----
  999 FORMAT(2F10.4,I5)
 1000 FORMAT(1H1,10X,82(1H*)/11X,1H*,80X,1H*/11X,1H*,10X,'ONE-DIMENSIONA
     1L CONVECTION-DISPERSION EQ. SOLUTION',20X,1H*)
 1001 FORMAT(20A4)
 1002 FORMAT(11X,1H*,20A4,1H*)
 1003 FORMAT(11X,1H*,80X,1H*/11X,82(1H*))
 1004 FORMAT(7(4X,A4,A2))
 1005 FORMAT(7F10.0)
 1006 FORMAT(7I10)
 1007 FORMAT(//11X,'INITIAL VALUES OF COEFFICIENTS'/11X,30(1H=)/12X,
     1'NAME',11X,'INITIAL VALUE')
 1008 FORMAT(11X,A4,A2,4(1H.),F12.4)
 1009 FORMAT(//11X,'OBSERVED DATA',/11X,13(1H=)/11X,'OBS. NO.',5X,'CONCE
     1NTRATION',6X,'DISTANCE',9X,'TIME')
 1010 FORMAT(11X,I5,6X,F12.4,4X,F12.4,4X,F12.4)
 1011 FORMAT(//11X,'ITERATION',6X,'SSQ',4X,5(7X,A4,A2))
 1012 FORMAT(11X,I5,3X,F13.6,2X,5(F13.5))
 1013 FORMAT(///,11X,'CORRELATION MATRIX'/11X,18(1H=)/14X,10(4X,I2,5X))
 1014 FORMAT(11X,I3,10(2X,F7.4,2X))
 1015 FORMAT(1H1,10X,'NON-LINEAR LEAST SQUARES ANALYSIS, FINAL RESULTS'
     1/11X,48(1H=)//72X,'95% CONFIDENCE LIMITS'/11X,'VARIABLE',4X,'NAME'
     2,8X,'VALUE',8X,'S.E.COEFF.',3X,'T-VALUE',5X,'LOWER',10X,'UPPER')
 1016 FORMAT(14X,I2,6X,A4,A2,1X,F13.5,3X,F13.5,2X,F8.2,1X,F13.5,
     12X,F13.5)
 1017 FORMAT(//11X,23(1H-),'ORDERED BY COMPUTER INPUT',24(1H-)/
     150X,'CONCENTRATION',12X,'RESI-'/11X,'NO',4X,'DISTANCE',9X,'TIME',
     210X,'OBS',9X,'FITTED',9X,'DUAL')
 1018 FORMAT(10X,I2,1X,F12.4,4(2X,F12.4))
 1019 FORMAT(//11X,27(1H-),'ORDERED BY RESIDUAL',28(1H-)/
     150X,'CONCENTRATION',12X,'RESI-'/11X,'NO',4X,'DISTANCE',9X,'TIME',
     210X,'OBS',9X,'FITTED',9X,'DUAL')
 1020 FORMAT(///11X,'END OF PROBLEM'/11X,14(1H=))
 1021 FORMAT(11X,1H*,10X,'DETERMINISTIC LINEAR EQUILIBRIUM ADSORPTION FO
     1R PULSE INJECTION',7X,1H*/11X,1H*,10X,'WITH FIRST- AND ZERO-ORDER
     2PRODUCTION AND DECAY',23X,1H*)
 1022 FORMAT(11X,1H*,10X,'DETERMINISTIC TWO-SITE/TWO-REGION NONEQUILIBRI
     1UM MODEL FOR    ',8X,1H*/11X,1H*,10X,'PULSE-TYPE INJECTION WITH NO
     2 PRODUCTION OR DECAY',22X,1H*)
 1023 FORMAT(11X,1H*,10X,'STOCHASTIC TRANSPORT MODEL WITH EQUILIBRIUM AD
     1SORPTION',16X,1H*/11X,1H*,10X,'ZERO-ORDER PRODUCTION AND FIRST-ORD
     2ER DECAY FOR UNIFORM PULSE INPUT',3X,1H*)
 1024 FORMAT(11X,1H*,10X,'SOLUTION FOR RESIDENT CONCENTRATIONS',34X,1H*)
 1025 FORMAT(11X,1H*,10X,'SOLUTION FOR FLUX CONCENTRATIONS',38X,1H*)
 1026 FORMAT(11X,'CI',8(1H.),F12.4)
 1028 FORMAT(//11X,'INPUT ERROR-- TOO MANY UNKNOWNS! '/11X,'ONE OF THE F
     1OLLOWING COEFFICIENTS MUST BE FIXED:')
 1029 FORMAT(60X,A4,A2)
 1030 FORMAT(//11X,9(1H-),'RESULTS FOR INITIAL COEFFICIENT VALUES',9(1H-
     1)/11X,'NO',8X,'DISTANCE',8X,'TIME',7X,'CONCENTRATION')
 1031 FORMAT(//11X,'INPUT ERROR: NONZERO INITIAL VALUES OF VARIABLE COEF
     1FICIENTS MUST BE SPECIFIED!'/11X,'FOR REACTION CONSTANTS BE SURE S
     2IGN OF COEFFICIENT IS CORRECT AS'/11X,'FITTING PROCEDURE WILL NOT
     3CHANGE SIGNS')
 1032 FORMAT(//11X,'INPUT ERROR: V,D AND R MUST BE GREATER THAN ZERO!')
 1033 FORMAT(11X,I2,3(3X,F12.4))
 1034 FORMAT(/11X,'CONVERGENCE CRITERIA NOT MET IN',I3,' ITERATIONS')
 1035 FORMAT(11X,1H*,10X,'NON-LINEAR LEAST-SQUARES ANALYSIS',37X,1H*)
 1036 FORMAT(11X,1H*,80X,1H*)
 1037 FORMAT(11X,1H*,10X,'REDUCED CONCENTRATION DATA',44X,1H*)
 1038 FORMAT(/11X,'NO FURTHER DECREASE IN SSQ OBTAINED AFTER ',I2,' TRIA
     1LS')
 1039 FORMAT(11X,1H*,10X,'STOCHASTIC TRANSPORT MODEL WITH EQUILIBRIUM AD
     1SORPTION',16X,1H*/11X,1H*,10X,'ZERO-ORDER PRODUCTION AND FIRST-ORD
     2ER DECAY FOR UNIFORM SOLUTE LOAD',3X,1H*)
 1040 FORMAT(11X,1H*,10X,'REDUCED CONCENTRATION AND TIME DATA',35X,1H*)
 1041 FORMAT(/11X,'RSQUARE FOR REGRESSION OF OBSERVED VS PREDICTED=',
     1F10.8/)
 1042 FORMAT(1H1,10X,'NON-LINEAR LEAST SQUARES ANALYSIS, FINAL RESULTS'
     1/11X,48(1H=)//64X,'95% CONFIDENCE LIMITS'/11X,'VARIABLE',4X,'NAME'
     2,8X,'VALUE',8X,'S.E.COEFF.',7X,'LOWER',10X,'UPPER')
 1043 FORMAT(14X,I2,6X,A4,A2,1X,F13.5,3X,F13.5,1X,F13.5,2X,F13.5)
 1044 FORMAT(6I10)
 1045 FORMAT(2F10.0,I10)
 1046 FORMAT(/11X,5(1H-),'INFLUENT CONCENTRATIONS FOR MULTIPLE PULSES',
     15(1H-)/15X,'NO',7X,'START TIME',9X,'END TIME',4X,'CONCENTRATION')
 1047 FORMAT(/11X,7(1H-),'INFLUENT MASS LOADS FOR MULTIPLE PULSES',
     17(1H-)/15X,'NO',7X,'START TIME',9X,'M0/THETA')
 1048 FORMAT(11X,I5,3(7X,F10.4))
 1049 FORMAT(11X,'C0',8(1H.),F12.4)
 2001 FORMAT(' Enter Input file name --> ')
 2002 FORMAT(' Enter Output file name -> ')
 2003 FORMAT(A15)
      STOP
      END
C
      SUBROUTINE MATINV(A,NP,B)
C
C     PURPOSE: PERFORM MATRIX INVERSION FOR PARAMETER ESTIMATION
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(7,7),B(7),INDEX(7,2)
      DO 2 J=1,7
    2   INDEX(J,1)=0
      I=0
    4 AMAX=-1.0
      DO 11 J=1,NP
        IF(INDEX(J,1)) 11,6,11
    6   DO 10 K=1,NP
          IF(INDEX(K,1)) 10,8,10
    8     P=DABS(A(J,K))
          IF(P.LE.AMAX) GO TO 10
          IR=J
          IC=K
          AMAX=P
   10 CONTINUE
   11 CONTINUE
      IF(AMAX) 30,30,14
   14 INDEX(IC,1)=IR
      IF(IR.EQ.IC) GO TO 18
      DO 16 L=1,NP
      P=A(IR,L)
      A(IR,L)=A(IC,L)
   16 A(IC,L)=P
      P=B(IR)
      B(IR)=B(IC)
      B(IC)=P
      I=I+1
      INDEX(I,2)=IC
   18 P=1./A(IC,IC)
      A(IC,IC)=1.0
      DO 20 L=1,NP
   20 A(IC,L)=A(IC,L)*P
      B(IC)=B(IC)*P
      DO 24 K=1,NP
      IF(K.EQ.IC) GO TO 24
      P=A(K,IC)
      A(K,IC)=0.0
      DO 22 L=1,NP
   22 A(K,L)=A(K,L)-A(IC,L)*P
      B(K)=B(K)-B(IC)*P
   24 CONTINUE
      GO TO 4
   26 IC=INDEX(I,2)
      IR=INDEX(IC,1)
      DO 28 K=1,NP
      P=A(K,IR)
      A(K,IR)=A(K,IC)
   28 A(K,IC)=P
      I=I-1
   30 IF(I) 26,32,26
   32 RETURN
      END
C
      SUBROUTINE MODEL(BN,CXT)
C
C     PURPOSE: ASSIGN COEFFICIENTS AND ROUTE EXECUTION FOR MODELS
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION BN(14),CXT(90)
      COMMON/MODAT1/X(90),T(90),INDEX(7),NOB,NREDU,NVAR
      COMMON/MODAT2/CI,C0,SOLOAD,XL,F1,F2,F3,F4,F5,R,VLNM,SDLN,DISP,XJ,
     1TJ,MODE,MODT
      COMMON/MODAT3/TPULSE(11),PULSE(11),CITEMP,NPULSE
      EXTERNAL CAVG
C      write(*,*) BN(3),R
C      R=1/BN(3)
C      write(*,*) BN(3),R,'****'
    
C
C     ----UPDATE COEFFICIENT ARRAY----
C      K=0
      NU1=NVAR+1
      NU2=NVAR*2
C      DO 2 I=NU1,NU2
C      IF(INDEX(I-NVAR).EQ.0) GO TO 2
C      K=K+1
C      BN(I)=BN(K)
C    2 CONTINUE
C
C     ----- ASSIGN PARAMETERS AND CHANGE FROM REDUCED TO ACTUAL TIMES
      CITEMP=CI
      V=BN(NU1)
      R=BN(NVAR+3)
      REDT=1.0
      IF(NREDU.NE.2) GO TO 8
      REDT=XL/V
      DO 4 I=1,NOB
    4 T(I)=T(I)*REDT
    8 IF(MODE.LE.6) F3=REDT*BN(NVAR+4)
      IF(MODE.GE.5) GO TO 150
      IF(MODE.GE.3) GO TO 100
      F1=V/R
      F2=BN(8)/R
      F4=BN(11)/R
      F5=BN(12)/R
C
C     ----SOLVE FOR MODELS 1 AND 2
   50 DO 75 J=1,NOB
      CXT(J)=0.0
      DO 65 I=1,NPULSE
      IF(NPULSE.EQ.1)GO TO 60
      C=0.0
      C0=PULSE(I+1)
      IF(I.EQ.2)CI=0.0
      IF((C0.EQ.0.0).AND.(I.GT.1))GO TO 65
      F3=TPULSE(I+1)-TPULSE(I)
   60 TCON=T(J)-TPULSE(I)
      IF(TCON.LT.0.0)GO TO 75
      CALL MOD12(C,X(J),TCON)
   65 CXT(J)=CXT(J)+C
   75 CI=CITEMP
      GO TO 350
C
C     ----SOLVE FOR MODELS 3 AND 4
  100 F1=V
      F2=V*XL/BN(8)
      F4=DMIN1(BN(11),0.9999D00)*R
C     WRITE(*,*) R,'%%%%%%'
      F5=BN(12)
      DO 125 J=1,NOB
      CXT(J)=0.0
      DO 115 I=1,NPULSE
      IF(NPULSE.EQ.1)GO TO 110
      C=0.0
      C0=PULSE(I+1)
      IF(I.EQ.2)CI=0.0
      IF((C0.EQ.0.0).AND.(I.GT.1))GO TO 115
      F3=TPULSE(I+1)-TPULSE(I)
  110 TCON=T(J)-TPULSE(I)
      IF(TCON.LT.0.0)GO TO 125
      CALL MOD34(C,X(J),TCON)
  115 CXT(J)=CXT(J)+C
  125 CI=CITEMP
      GO TO 350
C
C     ----SOLVE FOR MODELS 5 THRU 8
  150 F4=BN(12)/R
      F5=BN(13)/R
      SDLN=BN(14)
      VLNM=DLOG(V)-0.5*SDLN*SDLN
      DISP=BN(9)
      IF(MODE.GE.7) SOLOAD=BN(11)/C0
      VMIN1=DEXP(VLNM-3.9*SDLN)
      VMAX1=DEXP(VLNM+3.9*SDLN)
      IF((NPULSE.GT.1).AND.(MODE.LT.7))C0=PULSE(2)
      CMIN=DMAX1(C0,CI)*1.D-06
      MODT=MODE
      IF((MODT.EQ.5).OR.(MODT.EQ.7)) MODE=1
      IF((MODT.EQ.6).OR.(MODT.EQ.8)) MODE=2
      DO 175 J=1,NOB
      XJ=X(J)
      TJ=T(J)
      IF(CI.GT.0.0)GO TO 160
      PL=DMAX1(XJ/DISP,1.D-10)
      VMIN=DMAX1(VMIN1,DMIN1(0.14*DLOG(PL)*XJ/TJ-.05,0.9*XJ/TJ)*R)
      GO TO 165
  160 VMIN=VMIN1
  165 CALL LIMIT(VMIN,VMAX,VMAX1,CMIN)
      CALL ROMB(CAVG,CXT(J),VMIN,VMAX)
      IF(MODE.EQ.2) CXT(J)=CXT(J)/V
  175 CONTINUE
      MODE=MODT
  350 CONTINUE
      IF(NREDU.EQ.0) GO TO 360
      DO 355 I=1,NOB
      T(I)=T(I)/REDT
  355 CXT(I)=(CXT(I)-CI)/(C0-CI)
  360 CONTINUE
      RETURN
      END
C
      SUBROUTINE MOD12(CXT,X,TIME)
C
C     PURPOSE: TO CALCULATE C(X,T) FOR MODE=1
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/MODAT2/CI,C0,DM1,XL,VR,DR,T0,RX1R,RX0R,R,DM2,DM3,DM4,DM5,
     1DM6,MODE,MDMY
      IF(RX1R.NE.0.0) GO TO 50
C
C     ------CALCULATE C(X,T) FOR RX1R=0
      DO 20 M=1,2
      A=0.0
      B=0.0
      T=TIME+(1-M)*T0
      IF(T.LE.0.0) GO TO 20
      S2=(X-VR*T)/DSQRT(4.*DR*T)
      S6=VR*X/DR
      S7=(X+VR*T)/DSQRT(4.*DR*T)
      E1=EXF(0.0D00,S2)
      E2=EXF(S6,S7)
      IF(MODE.EQ.2) GO TO 2
      S3=VR*DSQRT(T/(DR*3.141593))
      S4=(X-VR*T)*(VR*T-X)/(4*DR*T)
      S5=-0.5*(1.+VR*X/DR+VR*VR*T/DR)
      E3=EXF(S4,0.0D00)
      GO TO 3
    2 S3=0.0
      S5=0.5
      E3=0.0
    3 A=0.5*E1+S3*E3+S5*E2
      IF(M.EQ.2) GO TO 30
      IF(RX0R.EQ.0.0) GO TO 10
      IF(MODE.EQ.2) GO TO 5
      S8=(X-VR*T+DR/VR)/(2*VR)
      S9=DSQRT(T*0.079577/DR)*(X+VR*T+2.*DR/VR)
      S10=T/2.-DR/(2.*VR*VR)+(X+VR*T)**2./(4*DR)
      GO TO 7
    5 S8=(X-VR*T)/(2.*VR)
      S9=0.0
      S10=-(X+VR*T)/(2.*VR)
    7 B=RX0R*(T+S8*E1-S9*E3+S10*E2)
   10 CXT=CI+(C0-CI)*A+B
   20 CONTINUE
   30 CXT=CXT-C0*A
      RETURN
C
C     ------CALCULATE RX1R.NE.0. CASE
   50 RAT=RX0R/RX1R
      DO 70 M=1,2
      A=0.0
      B=0.0
      T=TIME+(1-M)*T0
      IF(T.LE.0.0) GO TO 70
      S7=(X+VR*T)/DSQRT(4.*DR*T)
      IF(M.EQ.2) GO TO 55
      S1=-RX1R*T
      S2=(X-VR*T)/DSQRT(4.*DR*T)
      S6=VR*X/DR
      E1=EXF(0.0D00,S2)
      E2=EXF(S6,S7)
      IF(MODE.EQ.2) GO TO 52
      S3=VR*DSQRT(T/(DR*3.141593))
      S4=(X-VR*T)*(VR*T-X)/(4*DR*T)
      S5=-0.5*(1.+VR*X/DR+VR*VR*T/DR)
      E3=EXF(S4,0.0D00)
      GO TO 53
   52 S3=0.0
      S5=0.5
      E3=0.0
   53 A=EXF(S1,0.D00)*(1.-0.5*E1-S3*E3-S5*E2)
   55 CONTINUE
      U=DSQRT(VR*VR+4.*RX1R*DR)
      S9=(VR-U)*X/(2.*DR)
      S10=(X-U*T)/DSQRT(4.*DR*T)
      S12=(VR+U)*X/(2.*DR)
      S13=(X+U*T)/DSQRT(4.*DR*T)
      IF(MODE.EQ.2) GO TO 57
      S8=VR/(VR+U)
      S11=VR/(VR-U)
      S14=VR*VR/(2.*RX1R*DR)
      S15=VR*X/DR-RX1R*T
      S16=S14*EXF(S15,S7)
      GO TO 59
   57 S8=0.5
      S11=0.5
      S16=0.0
   59 B=S8*EXF(S9,S10)+S11*EXF(S12,S13)+S16
   60 IF(M.EQ.2) GO TO 80
      CXT=(CI-RAT)*A+(C0-RAT)*B+RAT
   70 CONTINUE
   80 CXT=CXT-C0*B
      RETURN
      END
C
      SUBROUTINE MOD34(CXT,X,T)
C
C     PURPOSE: CALCULATE C(X,T) FOR MODELS 3 AND 4
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/MODAT2/CI,C0,DM1,XL,V,P,T0,BETR,OMEGA,R,DM2,DM3,DM4,Z,TT,
     1MODE,MDMY
      DIMENSION WG(5),XG(5)
      EXTERNAL CC0
      DATA XG/.04691008,.23076534,.50000000,.76923466,.95308992/
      DATA WG/.1184634,.2393143,.2844444,.2393143,.1184634/
      TR0=V*T0/XL
      TR=V*T/XL
      Z=X/XL
      IF(Z.GT.0.0) GO TO 5
      Z=1.D-10
      IF(MODE.EQ.3) GO TO 5
      CXT=0.0
      IF(T.LE.T0) CXT=C0
      RETURN
    5 DO 20 M=1,2
      A=0.0
      TT=TR+(1-M)*TR0
      IF(TT.LE.0.) GO TO 20
      AP=DSQRT(1.+.05*P*Z)
      TMAX=DMIN1(TT,BETR*(Z+40.*(1.+AP)/P))
      TMIN=DMAX1(0.D00,BETR*(Z+40.*(1.-AP)/P))
      IF(TMAX.LE.TMIN) GO TO 15
      A1=0.0
      IF(TMIN.GT.0.) GO TO 10
      TMAX2=TMAX*1.D-4
      DO 8 I=1,5
      TAU=TMIN+(TMAX2-TMIN)*XG(I)
    8 A1=A1+WG(I)*CC0(TAU)
      A1=A1*(TMAX2-TMIN)
      TMIN=TMAX2
   10 CONTINUE
      CALL ROMB(CC0,A2,TMIN,TMAX)
      A=A1+A2
   15 IF(M.EQ.2) GO TO 30
      CXT=CI+(C0-CI)*A
   20 CONTINUE
   30 CXT=CXT-C0*A
      RETURN
      END
C
      SUBROUTINE LIMIT(VMIN,VMAX,VMAX1,CMIN)
C
C     PURPOSE:  TO CALCULATE INTEGRATION LIMITS FOR MODELS 5-8
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     ----- CALCULATE VMIN -----
      IF(VMIN.GE.VMAX1)RETURN
      F=(VMAX1/VMIN)**0.1
      DO 8 J=1,3
      DO 4 I=1,11
      CLST=CAVG(VMIN)
      IF(CLST.GT.CMIN/100.) GO TO 6
    4 VMIN=VMIN*F
      VMAX=VMIN
      RETURN
    6 SLOPE=(CAVG(VMIN*1.001)-CLST)/(0.001*VMIN)
      IF(SLOPE.GT.0.) GO TO 10
      VMIN=VMIN/F
    8 F=F**0.1
      GO TO 20
   10 IF(CLST.LT.CMIN) GO TO 20
      DO 12 I=1,5
      VMIN=VMIN-CLST/SLOPE
      IF(VMIN.LE.0.0)GO TO 15
      IF(CLST.LT.CMIN) GO TO 20
      CLST=CAVG(VMIN)
      SLOPE=(CAVG(VMIN*1.001)-CLST)/(0.001*VMIN)
      IF(SLOPE.LE.0.) GO TO 20
   12 CONTINUE
      GO TO 20
   15 VMIN=VMIN+CLST/SLOPE
C
C     ----- CALCULATE VMAX -----
   20 F=(VMAX1/VMIN)**0.1
      VMAX=VMAX1
      DO 28 J=1,3
      DO 24 I=1,11
      CLST=CAVG(VMAX)
      IF(CLST.GT.CMIN/100.) GO TO 26
   24 VMAX=VMAX/F
   26 SLOPE=(CAVG(VMAX*1.001)-CLST)/(0.001*VMAX)
      IF(SLOPE.LT.0.) GO TO 30
      VMAX=VMAX*F
   28 F=F**0.1
      RETURN
   30 IF(CLST.LT.CMIN) RETURN
      DO 32 I=1,5
      VMAX=VMAX-CLST/SLOPE
      IF(CLST.LT.CMIN) RETURN
      CLST=CAVG(VMAX)
      SLOPE=(CAVG(VMAX*1.001)-CLST)/(0.001*VMAX)
      IF(SLOPE.GE.0.) RETURN
   32 CONTINUE
      RETURN
      END
C
      SUBROUTINE ROMB(FUNC,AREA,XMIN,XMAX)
C
C     PURPOSE: PERFORM ROMBERG INTEGRATION ON LOG-TRANSFORMED INTERVAL
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION R(9,9)
      AREA=0.0
      IF(XMIN.GE.XMAX)RETURN
      LEVEL=9
      STOPER=0.00005
      XLN1=DLOG(XMIN)
      XLN2=DLOG(XMAX)
      DX1=XLN2-XLN1
      SUM=0.5*XMIN*FUNC(XMIN)
      AREA=SUM*DX1
      R(1,1)=AREA
      DX2=DX1/2.
      INC=1
      DO 20 I=2,LEVEL
      XLN=XLN1+DX2
      DO 4 M=1,INC
      XE=DEXP(XLN)
      SUM=SUM+XE*FUNC(XE)
    4 XLN=XLN+DX1
      AREA=SUM*DX2
      R(1,I)=AREA
      DO 17 J=2,I
      K=I+1-J
   17 R(J,K)=(4.**(J-1)*R(J-1,K+1)-R(J-1,K))/(4.**(J-1)-1)
      IF(R(I,1).GT.0.0) GO TO 18
      IF(I.GT.4) RETURN
      GO TO 19
   18 ERROR=DABS((R(I,1)-R(I-1,2))/R(I,1))
      IF((ERROR.LT.STOPER).AND.(I.GT.4)) RETURN
   19 DX1=DX1/2.
      DX2=DX2/2.
   20 INC=INC*2
      RETURN
      END
C
      FUNCTION CC0(TAU)
C
C     PURPOSE: CALCULATE ARGUMENT IN INTEGRAL FOR MODELS 3 AND 4
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/MODAT2/DM1,DM2,DM3,DM4,DM5,P,DM6,BETR,OMEGA,R,DM7,DM8,DM9,
     1Z,T,MODE,MDMY
      CC0=0.0
      G1=EXF(P*(BETR*Z-TAU)*(TAU-BETR*Z)/(4.*BETR*TAU),0.D00)
      IF(MODE.EQ.4) GO TO 5
      G2=DSQRT(P/(BETR*TAU))
      G=0.56419*G2*G1-P/(2.*BETR)*EXF(P*Z,G2/2.*(BETR*Z+TAU))
      GO TO 10
    5 G=(Z/TAU)*DSQRT(P*BETR/(12.5664*TAU))*G1
   10 IF(G.LT.1.D-07) RETURN
      A=OMEGA*TAU/BETR
      B=OMEGA*(T-TAU)/(R-BETR)
      CC0=G*GOLD(A,B)
      RETURN
      END
C
      FUNCTION CAVG(V)
C
C     PURPOSE: CALCULATE ARGUMENT IN INTEGRAL FOR MODELS 5-8
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/MODAT2/CI,C0,SOLOAD,XL,VR,DR,T0,RX1R,RX0R,R,VLNM,SDLN,DISP,
     1X,T,MODE,MODT
      COMMON/MODAT3/TPULSE(11),PULSE(11),CITEMP,NPULSE
      VLN=DLOG(V)
      VR=V/R
      DR=VR*DISP
      IF(MODT.GE.7) T0=SOLOAD/V
      C=0.0
      DO 30 I=1,NPULSE
      IF(NPULSE.EQ.1)GO TO 20
      IF(I.EQ.2)CI=0.0
      IF(MODT.GE.7) GO TO 10
      CXT=0.0
      C0=PULSE(I+1)
      IF((C0.EQ.0.0).AND.(I.GT.1))GO TO 30
      T0=TPULSE(I+1)-TPULSE(I)
      GO TO 20
   10 T0=PULSE(I+1)/(V*C0)
   20 TCON=T-TPULSE(I)
      IF(TCON.LE.0.0)GO TO 40
      CALL MOD12(CXT,X,TCON)
   30 C=C+CXT
   40 CI=CITEMP
      ARG=DMIN1(1.D02,(VLN-VLNM)*(VLN-VLNM)/(2.*SDLN*SDLN))
      PROB=DEXP(-ARG)/(2.50663*SDLN*V)
      IF(C.LT.1.D-70)C=0.D00
      IF(MODE.EQ.1) CAVG=PROB*C
      IF(MODE.EQ.2) CAVG=PROB*C*V
      RETURN
      END
C
      FUNCTION EXF(A,B)
C
C     PURPOSE:  TO CALCULATE EXP(A) ERFC(B)
C
      IMPLICIT REAL*8(A-H,O-Z)
      EXF=0.D00
      IF((DABS(A).GT.100.).AND.(B.LE.0.)) RETURN
      C=A-B*B
      IF((DABS(C).GT.100.).AND.(B.GE.0.)) RETURN
      IF(C.LT.-100.) GO TO 3
      X=DABS(B)
      IF(X.GT.3.0) GO TO 1
      T=1./(1.+.3275911*X)
      Y=T*(.2548296-T*(.2844967-T*(1.421414-T*(1.453152-1.061405*T))))
      GO TO 2
    1 Y=.5641896/(X+.5/(X+1./(X+1.5/(X+2./(X+2.5/X+1.)))))
    2 EXF=Y*DEXP(C)
    3 IF(B.LT.0.0) EXF=2.*DEXP(A)-EXF
      RETURN
      END
C
      FUNCTION GOLD(X,Y)
C
C     PURPOSE: TO CALCULATE GOLDSTEIN'S J-FUNCTION J(X,Y)
C
      IMPLICIT REAL*8(A-H,O-Z)
      GOLD=0.0
      BF=0.0
      E=2.*DSQRT(DMAX1(0.D0,X*Y))
      Z=X+Y-E
      IF(Z.GT.17.) GO TO 8
      IF(E.NE.0.) GO TO 2
      GOLD=DEXP(-X)
      RETURN
    2 A=DMAX1(X,Y)
      B=DMIN1(X,Y)
      NT=11.+2.*B+0.3*A
      IF(NT.GT.25) GO TO 6
      I=0
      IF(X.LT.Y) I=1
      GXY=1.+I*(B-1.)
      GXYO=GXY
      GX=1.0
      GY=GXY
      GZ=1.0
      DO 4 K=1,NT
      GX=GX*A/K
      GY=GY*B/(K+I)
      GZ=GZ+GX
      GXY=GXY+GY*GZ
      IF((GXY-GXYO)/GXY.LT.1.D-08) GO TO 5
    4 GXYO=GXY
    5 GOLD=GXY*EXF(-X-Y,0.0D00)
      GO TO 8
    6 DA=DSQRT(A)
      DB=DSQRT(B)
      P=3.75/E
      B0=(.3989423+P*(.01328592+P*(.00225319-P*(.00157565-P*(.00916281-P
     1*(.02057706-P*(.02635537-P*(.01647633-.00392377*P))))))))/DSQRT(E)
      BF=B0*EXF(-Z,0.0D00)
      P=1./(1.+.3275911*(DA-DB))
      ERF=P*(.2548296-P*(.2844967-P*(1.421414-P*(1.453152-P*1.061405))))
      P=0.25/E
      C0=1.-1.772454*(DA-DB)*ERF
      C1=0.5-Z*C0
      C2=0.75-Z*C1
      C3=1.875-Z*C2
      C4=6.5625-Z*C3
      SUM=.1994711*(A-B)*P*(C0+1.5*P*(C1+1.666667*P*(C2+1.75*P*(C3+P*(C4
     1*(1.8-3.3*P*Z)+97.45313*P)))))
      GOLD=0.5*BF+(.3535534*(DA+DB)*ERF+SUM)*BF/(B0*DSQRT(E))
    8 IF(X.LT.Y) GOLD=1.+BF-GOLD
      RETURN
      END


      SUBROUTINE RANDOM(RANNUM)
      INTEGER M,CONST1
      REAL RANNUM,CONST2
      PARAMETER (CONST1=2147483647, CONST2=.4656613E-9)
      SAVE
      DATA M /0/
      IF(M.EQ.0) M=INT(RANNUM)
      M=M*65539
      IF(M.LT.0) M=(M+1)+CONST1
      RANNUM=M*CONST2
      END

      SUBROUTINE RANDOM2(RANNUM)
      INTEGER M,CONST1
      REAL RANNUM,CONST2
      PARAMETER (CONST1=2147483647, CONST2=.4656613E-9)
      SAVE
      DATA M /0/
      IF(M.EQ.0) M=INT(RANNUM)
      M=M*65539
      IF(M.LT.0) M=(M+1)+CONST1
      RANNUM=M*CONST2
      END

      SUBROUTINE RANDOM3(RANNUM)
      INTEGER M,CONST1
      REAL RANNUM,CONST2
      PARAMETER (CONST1=2147483647, CONST2=.4656613E-9)
      SAVE
      DATA M /0/
      IF(M.EQ.0) M=INT(RANNUM)
      M=M*65539
      IF(M.LT.0) M=(M+1)+CONST1
      RANNUM=M*CONST2
      END

      SUBROUTINE RANDOM4(RANNUM)
      INTEGER M,CONST1
      REAL RANNUM,CONST2
      PARAMETER (CONST1=2147483647, CONST2=.4656613E-9)
      SAVE
      DATA M /0/
      IF(M.EQ.0) M=INT(RANNUM)
      M=M*65539
      IF(M.LT.0) M=(M+1)+CONST1
      RANNUM=M*CONST2
      END

      SUBROUTINE RANDOM5(RANNUM)
      INTEGER M,CONST1
      REAL RANNUM,CONST2
      PARAMETER (CONST1=2147483647, CONST2=.4656613E-9)
      SAVE
      DATA M /0/
      IF(M.EQ.0) M=INT(RANNUM)
      M=M*65539
      IF(M.LT.0) M=(M+1)+CONST1
      RANNUM=M*CONST2
      END
